import { createRoute } from "../../../modules/api-utils/createRoute";
import { unifiSites } from "../../../managers/unifiSites";
import { apiResponse } from "../../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../../middleware/authorization";
import { processObjectValuePerms } from "../../../modules/permission-utils/processObjectPermissions";

/* GET /v1/unifi/site/:id */
export default createRoute(
  "get",
  ["/site/:id"],
  async (c) => {
    const site = await unifiSites.fetch(c.req.param("id"));

    const gatedData = await processObjectValuePerms(
      site,
      "obj.unifiSite",
      c.get("user"),
    );

    const response = apiResponse.successful(
      "UniFi Site Fetched Successfully!",
      gatedData,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({ permissions: ["unifi.access", "unifi.sites.fetch"] }),
);
